# coding: utf-8

"""
    BioT User Management Service

    APIs document (version: 7.17.2)

    The version of the OpenAPI document: 7.17.2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from biotmed_ums_sdk.models.role_basic_info import RoleBasicInfo
from typing import Optional, Set
from typing_extensions import Self

class GroupResponse(BaseModel):
    """
    GroupResponse
    """ # noqa: E501
    name: Annotated[str, Field(min_length=0, strict=True, max_length=45)]
    id: Optional[StrictStr] = None
    roles: Optional[List[RoleBasicInfo]] = None
    built_in: Optional[StrictBool] = Field(default=None, alias="builtIn")
    creation_time: Optional[datetime] = Field(default=None, alias="creationTime")
    last_modified_time: Optional[datetime] = Field(default=None, alias="lastModifiedTime")
    __properties: ClassVar[List[str]] = ["name", "id", "roles", "builtIn", "creationTime", "lastModifiedTime"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GroupResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in roles (list)
        _items = []
        if self.roles:
            for _item in self.roles:
                if _item:
                    _items.append(_item.to_dict())
            _dict['roles'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GroupResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "id": obj.get("id"),
            "roles": [RoleBasicInfo.from_dict(_item) for _item in obj["roles"]] if obj.get("roles") is not None else None,
            "builtIn": obj.get("builtIn"),
            "creationTime": obj.get("creationTime"),
            "lastModifiedTime": obj.get("lastModifiedTime")
        })
        return _obj


