# coding: utf-8

"""
    BioT User Management Service

    APIs document (version: 7.17.2)

    The version of the OpenAPI document: 7.17.2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from biotmed_ums_sdk.models.secret_key_data import SecretKeyData
from typing import Optional, Set
from typing_extensions import Self

class UpdateServiceUserV2Response(BaseModel):
    """
    UpdateServiceUserV2Response
    """ # noqa: E501
    active: Optional[StrictBool] = None
    role_id: StrictStr = Field(description="A UUID formatted string", alias="roleId")
    type: StrictStr
    owner_organization_id: Optional[StrictStr] = Field(default=None, description="A UUID formatted string", alias="ownerOrganizationId")
    name: Optional[Annotated[str, Field(min_length=0, strict=True, max_length=100)]] = None
    access_token_expiration_in_minutes: Optional[Annotated[int, Field(strict=True, ge=1)]] = Field(default=None, alias="accessTokenExpirationInMinutes")
    id: Optional[StrictStr] = None
    secret_keys: Optional[List[SecretKeyData]] = Field(default=None, alias="secretKeys")
    __properties: ClassVar[List[str]] = ["active", "roleId", "type", "ownerOrganizationId", "name", "accessTokenExpirationInMinutes", "id", "secretKeys"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['INTERNAL_SERVICE', 'EXTERNAL_SERVICE']):
            raise ValueError("must be one of enum values ('INTERNAL_SERVICE', 'EXTERNAL_SERVICE')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateServiceUserV2Response from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in secret_keys (list)
        _items = []
        if self.secret_keys:
            for _item in self.secret_keys:
                if _item:
                    _items.append(_item.to_dict())
            _dict['secretKeys'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateServiceUserV2Response from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "active": obj.get("active"),
            "roleId": obj.get("roleId"),
            "type": obj.get("type"),
            "ownerOrganizationId": obj.get("ownerOrganizationId"),
            "name": obj.get("name"),
            "accessTokenExpirationInMinutes": obj.get("accessTokenExpirationInMinutes"),
            "id": obj.get("id"),
            "secretKeys": [SecretKeyData.from_dict(_item) for _item in obj["secretKeys"]] if obj.get("secretKeys") is not None else None
        })
        return _obj


